<?php

namespace Drupal\mcapi_bursers\Plugin\EntityReferenceSelection;

use Drupal\mcapi\Plugin\EntityReferenceSelection\WalletSelection;

/**
 * Provide default Wallet selection handler.
 *
 * Overrides the my_wallets_only setting to include bursered wallets
 *
 * @EntityReferenceSelection(
 *   id = "default:mcapi_wallet_burser",
 *   label = @Translation("Wallet (included bursered) selection"),
 *   entity_types = {"mcapi_wallet"},
 *   group = "default"
 * )
 */
class WalletBurserSelection extends WalletSelection {

  /**
   * {@inheritdoc}
   */
  public function buildEntityQuery($match = NULL, $match_operator = 'CONTAINS') {
    $query = $this->entityTypeManager->getStorage('mcapi_wallet')->getQuery()->accessCheck(TRUE);
    if ($match) {
      $query->condition('name', $match, $match_operator);
    }

    if ($this->configuration['my_wallets_only']) {
      $query->condition('holder.target_type', 'user');
      $db_or = $query->orConditionGroup();
      $db_or->condition('holder.target_id', $this->currentUser->id(), 'IN')
        ->condition('bursers', $this->currentUser->id());
      $query->condition($db_or);
    }
    return $query;
  }

}