<?php

namespace Drupal\mcapi_bursers\Plugin\Field\FieldType;

use Drupal\mcapi\Plugin\Field\FieldType\WalletReferenceItem;

/**
 * Defines the burser user entity reference field type.
 *
 * Differs from wallet_reference only by the selection handler
 *
 * @FieldType(
 *   id = "burser_reference",
 *   label = @Translation("Bursers"),
 *   description = @Translation("Users who can control the wallet"),
 *   category = @Translation("Community Accounting"),
 *   default_formatter = "entity_reference_label",
 *   default_widget = "entity_reference_autocomplete",
 *   list_class = "\Drupal\mcapi_bursers\Plugin\Field\FieldType\BurserReferenceFieldItemList"
 * )
 */
class BurserReferenceItem extends WalletReferenceItem {

  public static function defaultFieldSettings() {
    return [
      'handler' => 'default:mcapi_wallet_burser'
    ] + parent::defaultFieldSettings();
  }

}
