<?php

namespace Drupal\mcapi_credcom_leaf\Access;

use Symfony\Component\HttpFoundation\RequestStack;
use Symfony\Component\HttpKernel\Exception\UnauthorizedHttpException;
use Drupal\Core\Access\AccessResult;

/**
 * Access check for requests from rootwards nodes.
 */
class HashChecker implements \Drupal\Core\Routing\Access\AccessInterface{

  /**
   * Checks access.
   *
   * @param RequestStack $request_stack
   *   The currently logged in account.
   *
   * @return \Drupal\Core\Access\AccessResultInterface
   *   The access result.
   */
  public function access(RequestStack $request_stack) {
    $request = $request_stack->getCurrentRequest();
    if ($request->headers->has('Upstream-Node')) {
      if (mcapi_credcom_leaf_lastHash() == $request->headers->get('Upstream-Hash')) {
        return AccessResult::allowed();
      }
    }

    return new HttpException(409, 'Hash mismatch');
    return AccessResult::forbidden();
  }

}
