<?php

namespace Drupal\mcapi\Controller;

use Drupal\mcapi\TransactionOperations;
use Drupal\action\ActionListBuilder;

/**
 * Extends the actionListBuilder to exclude the special transaction actions
 *
 * @see \Drupal\system\Entity\Action
 * @see action_entity_info()
 */
class ActionListOverride extends ActionListBuilder {

  /**
   * {@inheritdoc}
   */
  public function load() {
    $entities = parent::load();
    // Remove the mcapi actions from the list of actions.
    foreach (TransactionOperations::loadAllActions(FALSE) as $id) {
      unset($entities[$id]);
    }
    return $entities;
  }

}
