<?php

namespace Drupal\mcapi\Plugin\Validation\Constraint;

use Drupal\user\Entity\User;
use Symfony\Component\Validator\ConstraintValidator;
use Symfony\Component\Validator\Constraint;


/**
 * Check that the two wallets in the transaction are different.
 */
class AutowalletValidator extends ConstraintValidator {

  /**
   * {@inheritdoc}
   */
  public function validate($entity, Constraint $constraint) {
    // N.B This is a clone of the entity.
    if (isset($entity->newWallet)) {
      if ($entity->newWallet->holder->entity instanceOf User) {
        // needed to pass validation
        // No need to deactivate because we are working on a clone.
        $entity->newWallet->holder->entity->activate();
      }
      $violationList = $entity->newWallet->validate();
      // Tests show that only the first message is displayed.s
      foreach($violationList as $v) { // specific errors
        $this->context->addViolation($v->getMessage());
      }
    }
  }

}
