<?php

namespace Drupal\mcapi\Plugin\Validation\Constraint;

use Symfony\Component\Validator\ConstraintValidator;
use Symfony\Component\Validator\Constraint;

/**
 * Check that the two wallets in the transaction are different.
 */
class DifferentWalletsConstraintValidator extends ConstraintValidator {

  /**
   * {@inheritdoc}
   */
  public function validate($transaction, Constraint $constraint) {
    // Check the payer and payee aren't the same.
    if ($transaction->payee->target_id == $transaction->payer->target_id) {
      $this->context
        ->addViolation($constraint->sameMessage);
    }
  }

}
