<?php

namespace Drupal\mcapi\Plugin\migrate\destination;

use Drupal\migrate\Plugin\migrate\destination\EntityContentBase;
use Drupal\migrate\Row;
use Drupal\user\Entity\User;

/**
 * @MigrateDestination(
 *   id = "entity:mcapi_wallet"
 * )
 */
class EntityWallet extends EntityContentBase {

  /**
   * {@inheritdoc}
   */
  public function import(Row $row, array $old_destination_id_values = []) {
    // In D7 only users could hold wallets.
    $holder = User::load($row->getDestinationProperty('holder__target_id'));
    $row->setDestinationProperty('holder', $holder);
    return parent::import($row, $old_destination_id_values);
  }

}
